package v0

// DO NOT EDIT: this file is automatically generated by ./tools/generator in this repo

type Request struct {
	ID      string `json:"id"`
	Version string `json:"version"`
	Type    string `json:"type"`
}

type AnswerMessage struct {
	ID     int64  `json:"id,omitempty"`
	Opaque string `json:"opaque,omitempty"`
	Sdp    string `json:"sdp,omitempty"`
}

type BusyMessage struct {
	ID int64 `json:"id,omitempty"`
}

type ConfigurationMessage struct {
	LinkPreviews                   *Optional `json:"linkPreviews,omitempty"`
	ReadReceipts                   *Optional `json:"readReceipts,omitempty"`
	TypingIndicators               *Optional `json:"typingIndicators,omitempty"`
	UnidentifiedDeliveryIndicators *Optional `json:"unidentifiedDeliveryIndicators,omitempty"`
}

type DeviceInfo struct {
	Created  int64  `json:"created,omitempty"`
	ID       int64  `json:"id,omitempty"`
	LastSeen int64  `json:"lastSeen,omitempty"`
	Name     string `json:"name,omitempty"`
}

type HangupMessage struct {
	DeviceId int32 `json:"deviceId,omitempty"`
	ID       int64 `json:"id,omitempty"`
	Legacy   bool  `json:"legacy,omitempty"`
	Type     *Type `json:"type,omitempty"`
}

type IceUpdateMessage struct {
	ID     int64  `json:"id,omitempty"`
	Opaque string `json:"opaque,omitempty"`
	Sdp    string `json:"sdp,omitempty"`
}

type JsonAccount struct {
	DeviceId   int32  `json:"deviceId,omitempty"`
	Filename   string `json:"filename,omitempty"`
	Has_keys   bool   `json:"has_keys,omitempty"`
	Registered bool   `json:"registered,omitempty"`
	Subscribed bool   `json:"subscribed,omitempty"`
	Username   string `json:"username,omitempty"`
	UUID       string `json:"uuid,omitempty"`
}

type JsonAccountList struct {
	Accounts []*JsonAccount `json:"accounts,omitempty"`
}

type JsonAttachment struct {
	Blurhash       string `json:"blurhash,omitempty"`
	Caption        string `json:"caption,omitempty"`
	ContentType    string `json:"contentType,omitempty"`
	CustomFilename string `json:"customFilename,omitempty"`
	Digest         string `json:"digest,omitempty"`
	Filename       string `json:"filename,omitempty"`
	Height         int32  `json:"height,omitempty"`
	ID             string `json:"id,omitempty"`
	Key            string `json:"key,omitempty"`
	Size           int32  `json:"size,omitempty"`
	StoredFilename string `json:"storedFilename,omitempty"`
	VoiceNote      bool   `json:"voiceNote,omitempty"`
	Width          int32  `json:"width,omitempty"`
}

type JsonCallMessage struct {
	AnswerMessage       *AnswerMessage      `json:"answerMessage,omitempty"`
	BusyMessage         *BusyMessage        `json:"busyMessage,omitempty"`
	DestinationDeviceId int32               `json:"destinationDeviceId,omitempty"`
	HangupMessage       *HangupMessage      `json:"hangupMessage,omitempty"`
	IceUpdateMessages   []*IceUpdateMessage `json:"iceUpdateMessages,omitempty"`
	IsMultiRing         bool                `json:"isMultiRing,omitempty"`
	OfferMessage        *OfferMessage       `json:"offerMessage,omitempty"`
}

type JsonPreview struct {
	Attachment *JsonAttachment `json:"attachment,omitempty"`
	Title      string          `json:"title,omitempty"`
	Url        string          `json:"url,omitempty"`
}

type JsonQuotedAttachment struct {
	ContentType string          `json:"contentType,omitempty"`
	FileName    string          `json:"fileName,omitempty"`
	Thumbnail   *JsonAttachment `json:"thumbnail,omitempty"`
}

type JsonReceiptMessage struct {
	Timestamps []int64 `json:"timestamps,omitempty"`
	Type       string  `json:"type,omitempty"`
	When       int64   `json:"when,omitempty"`
}

type JsonSticker struct {
	Attachment *JsonAttachment `json:"attachment,omitempty"`
	PackID     string          `json:"packID,omitempty"`
	PackKey    string          `json:"packKey,omitempty"`
	StickerID  int32           `json:"stickerID,omitempty"`
}

type JsonStickerPackOperationMessage struct {
	PackID  string `json:"packID,omitempty"`
	PackKey string `json:"packKey,omitempty"`
	Type    string `json:"type,omitempty"`
}

type JsonTypingMessage struct {
	Action    string `json:"action,omitempty"`
	GroupId   string `json:"groupId,omitempty"`
	Timestamp int64  `json:"timestamp,omitempty"`
}

type Name struct {
	Display *Optional `json:"display,omitempty"`
	Family  *Optional `json:"family,omitempty"`
	Given   *Optional `json:"given,omitempty"`
	Middle  *Optional `json:"middle,omitempty"`
	Prefix  *Optional `json:"prefix,omitempty"`
	Suffix  *Optional `json:"suffix,omitempty"`
}

type OfferMessage struct {
	ID     int64  `json:"id,omitempty"`
	Opaque string `json:"opaque,omitempty"`
	Sdp    string `json:"sdp,omitempty"`
	Type   *Type  `json:"type,omitempty"`
}

type Optional struct {
	Present bool `json:"present,omitempty"`
}

type RemoteDelete struct {
	TargetSentTimestamp int64 `json:"targetSentTimestamp,omitempty"`
}

type SharedContact struct {
	Address      *Optional `json:"address,omitempty"`
	Avatar       *Optional `json:"avatar,omitempty"`
	Email        *Optional `json:"email,omitempty"`
	Name         *Name     `json:"name,omitempty"`
	Organization *Optional `json:"organization,omitempty"`
	Phone        *Optional `json:"phone,omitempty"`
}

type Success struct {
	Duration     int64 `json:"duration,omitempty"`
	NeedsSync    bool  `json:"needsSync,omitempty"`
	Unidentified bool  `json:"unidentified,omitempty"`
}

type Type struct {
}
