package v1

// DO NOT EDIT: this file is automatically generated by ./tools/generator in this repo

import (
	"encoding/json"
	"fmt"
	"log"
	"math/rand"

	"gitlab.com/signald/signald-go/signald"
)

// Submit: Accept a v2 group invitation. Note that you must have a profile name set to join groups.
func (r *AcceptInvitationRequest) Submit(conn *signald.Signald) (response JsonGroupV2Info, err error) {
	r.Version = "v1"
	r.Type = "accept_invitation"
	if r.ID == "" {
		r.ID = generateID()
	}

	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return response, err
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}
	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return response, err
	}

	return response, nil

}

// Submit: approve a request to join a group
func (r *ApproveMembershipRequest) Submit(conn *signald.Signald) (response JsonGroupV2Info, err error) {
	r.Version = "v1"
	r.Type = "approve_membership"
	if r.ID == "" {
		r.ID = generateID()
	}

	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return response, err
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}
	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return response, err
	}

	return response, nil

}

// Submit: Query the server for the latest state of a known group
func (r *GetGroupRequest) Submit(conn *signald.Signald) (response JsonGroupV2Info, err error) {
	r.Version = "v1"
	r.Type = "get_group"
	if r.ID == "" {
		r.ID = generateID()
	}

	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return response, err
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}
	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return response, err
	}

	return response, nil

}

// Submit: list all linked devices on a Signal account
func (r *GetLinkedDevicesRequest) Submit(conn *signald.Signald) (response LinkedDevices, err error) {
	r.Version = "v1"
	r.Type = "get_linked_devices"
	if r.ID == "" {
		r.ID = generateID()
	}

	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return response, err
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}
	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return response, err
	}

	return response, nil

}

// Submit: Get all information available about a user
func (r *GetProfileRequest) Submit(conn *signald.Signald) (response Profile, err error) {
	r.Version = "v1"
	r.Type = "get_profile"
	if r.ID == "" {
		r.ID = generateID()
	}

	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return response, err
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}
	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return response, err
	}

	return response, nil

}

// Submit: Join a group using the a signal.group URL. Note that you must have a profile name set to join groups.
func (r *JoinGroupRequest) Submit(conn *signald.Signald) (response JsonGroupJoinInfo, err error) {
	r.Version = "v1"
	r.Type = "join_group"
	if r.ID == "" {
		r.ID = generateID()
	}

	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return response, err
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}
	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return response, err
	}

	return response, nil

}

func (r *MarkReadRequest) Submit(conn *signald.Signald) error {
	r.Version = "v1"
	r.Type = "mark_read"
	if r.ID == "" {
		r.ID = generateID()
	}

	return conn.RawRequest(r)

}

func (r *ProtocolRequest) Submit(conn *signald.Signald) error {
	r.Version = "v1"
	r.Type = "protocol"
	if r.ID == "" {
		r.ID = generateID()
	}

	return conn.RawRequest(r)

}

// Submit: react to a previous message
func (r *ReactRequest) Submit(conn *signald.Signald) (response SendResponse, err error) {
	r.Version = "v1"
	r.Type = "react"
	if r.ID == "" {
		r.ID = generateID()
	}

	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return response, err
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}
	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return response, err
	}

	return response, nil

}

// Submit: Remove a linked device from the Signal account. Only allowed when the local device id is 1
func (r *RemoveLinkedDeviceRequest) Submit(conn *signald.Signald) error {
	r.Version = "v1"
	r.Type = "remove_linked_device"
	if r.ID == "" {
		r.ID = generateID()
	}

	return conn.RawRequest(r)

}

// Submit: Resolve a partial JsonAddress with only a number or UUID to one with both. Anywhere that signald accepts a JsonAddress will except a partial, this is a convenience function for client authors, mostly because signald doesn't resolve all the partials it returns
func (r *ResolveAddressRequest) Submit(conn *signald.Signald) (response JsonAddress, err error) {
	r.Version = "v1"
	r.Type = "resolve_address"
	if r.ID == "" {
		r.ID = generateID()
	}

	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return response, err
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}
	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return response, err
	}

	return response, nil

}

func (r *SendRequest) Submit(conn *signald.Signald) (response SendResponse, err error) {
	r.Version = "v1"
	r.Type = "send"
	if r.ID == "" {
		r.ID = generateID()
	}

	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return response, err
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}
	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return response, err
	}

	return response, nil

}

func (r *SetProfile) Submit(conn *signald.Signald) error {
	r.Version = "v1"
	r.Type = "set_profile"
	if r.ID == "" {
		r.ID = generateID()
	}

	return conn.RawRequest(r)

}

// Submit: modify a group
func (r *UpdateGroupRequest) Submit(conn *signald.Signald) (response GroupInfo, err error) {
	r.Version = "v1"
	r.Type = "update_group"
	if r.ID == "" {
		r.ID = generateID()
	}

	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return response, err
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}
	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return response, err
	}

	return response, nil

}

func (r *VersionRequest) Submit(conn *signald.Signald) (response JsonVersionMessage, err error) {
	r.Version = "v1"
	r.Type = "version"
	if r.ID == "" {
		r.ID = generateID()
	}

	err = conn.RawRequest(r)
	if err != nil {
		log.Println("signald-go: error submitting request to signald")
		return response, err
	}

	responseChannel := conn.GetResponseListener(r.ID)
	defer conn.CloseResponseListener(r.ID)

	rawResponse := <-responseChannel
	if rawResponse.Error != nil {
		err = fmt.Errorf("signald error: %s", string(rawResponse.Error))
		return
	}
	err = json.Unmarshal(rawResponse.Data, &response)
	if err != nil {
		rawResponseJson, _ := rawResponse.Data.MarshalJSON()
		log.Println("signald-go: error unmarshalling response from signald of type", rawResponse.Type, string(rawResponseJson))
		return response, err
	}

	return response, nil

}

const idsize = 10

var charset = []rune("abcdefghijklmnopqrstuvwxyz0123456789")

func generateID() string {
	id := make([]rune, idsize)
	for i := range id {
		id[i] = charset[rand.Intn(len(charset))]
	}
	return string(id)
}
